import { Plugin as B, PluginKey as N, Selection as P, TextSelection as S, NodeSelection as ae } from "@tiptap/pm/state";
import { DecorationSet as ge, Decoration as ke } from "@tiptap/pm/view";
import "@tiptap/pm/keymap";
import { Fragment as F, Slice as ye, DOMParser as we } from "@tiptap/pm/model";
import { liftTarget as xe, joinPoint as ce, canSplit as L, ReplaceStep as be, ReplaceAroundStep as Se, canJoin as le } from "@tiptap/pm/transform";
import { createParagraphNear as Me, deleteSelection as Ae, exitCode as Te, joinUp as Ce, joinDown as ve, joinBackward as Ee, joinForward as Ie, joinTextblockBackward as $e, joinTextblockForward as Be, lift as Ne, liftEmptyBlock as Oe, newlineInCode as Pe, selectNodeBackward as je, selectNodeForward as Fe, selectParentNode as Le, selectTextblockEnd as Re, selectTextblockStart as ze, setBlockType as ee, wrapIn as De } from "@tiptap/pm/commands";
import { liftListItem as We, sinkListItem as Ke, wrapInList as He } from "@tiptap/pm/schema-list";
import { getHighlighter as Ve, bundledLanguages as _e, bundledThemes as Je } from "shiki";
function de(t) {
  const { state: e, transaction: n } = t;
  let { selection: r } = n, { doc: o } = n, { storedMarks: s } = n;
  return {
    ...e,
    apply: e.apply.bind(e),
    applyTransaction: e.applyTransaction.bind(e),
    plugins: e.plugins,
    schema: e.schema,
    reconfigure: e.reconfigure.bind(e),
    toJSON: e.toJSON.bind(e),
    get storedMarks() {
      return s;
    },
    get selection() {
      return r;
    },
    get doc() {
      return o;
    },
    get tr() {
      return r = n.selection, o = n.doc, s = n.storedMarks, n;
    }
  };
}
class Ge {
  constructor(e) {
    this.editor = e.editor, this.rawCommands = this.editor.extensionManager.commands, this.customState = e.state;
  }
  get hasCustomState() {
    return !!this.customState;
  }
  get state() {
    return this.customState || this.editor.state;
  }
  get commands() {
    const { rawCommands: e, editor: n, state: r } = this, { view: o } = n, { tr: s } = r, i = this.buildProps(s);
    return Object.fromEntries(Object.entries(e).map(([a, c]) => [a, (...f) => {
      const l = c(...f)(i);
      return !s.getMeta("preventDispatch") && !this.hasCustomState && o.dispatch(s), l;
    }]));
  }
  get chain() {
    return () => this.createChain();
  }
  get can() {
    return () => this.createCan();
  }
  createChain(e, n = !0) {
    const { rawCommands: r, editor: o, state: s } = this, { view: i } = o, a = [], c = !!e, d = e || s.tr, f = () => (!c && n && !d.getMeta("preventDispatch") && !this.hasCustomState && i.dispatch(d), a.every((u) => u === !0)), l = {
      ...Object.fromEntries(Object.entries(r).map(([u, p]) => [u, (...h) => {
        const g = this.buildProps(d, n), k = p(...h)(g);
        return a.push(k), l;
      }])),
      run: f
    };
    return l;
  }
  createCan(e) {
    const { rawCommands: n, state: r } = this, o = !1, s = e || r.tr, i = this.buildProps(s, o);
    return {
      ...Object.fromEntries(Object.entries(n).map(([c, d]) => [c, (...f) => d(...f)({ ...i, dispatch: void 0 })])),
      chain: () => this.createChain(s, o)
    };
  }
  buildProps(e, n = !0) {
    const { rawCommands: r, editor: o, state: s } = this, { view: i } = o, a = {
      tr: e,
      editor: o,
      view: i,
      state: de({
        state: s,
        transaction: e
      }),
      dispatch: n ? () => {
      } : void 0,
      chain: () => this.createChain(e, n),
      can: () => this.createCan(e),
      get commands() {
        return Object.fromEntries(Object.entries(r).map(([c, d]) => [c, (...f) => d(...f)(a)]));
      }
    };
    return a;
  }
}
function w(t, e, n) {
  return t.config[e] === void 0 && t.parent ? w(t.parent, e, n) : typeof t.config[e] == "function" ? t.config[e].bind({
    ...n,
    parent: t.parent ? w(t.parent, e, n) : null
  }) : t.config[e];
}
function Ue(t) {
  const e = t.filter((o) => o.type === "extension"), n = t.filter((o) => o.type === "node"), r = t.filter((o) => o.type === "mark");
  return {
    baseExtensions: e,
    nodeExtensions: n,
    markExtensions: r
  };
}
function y(t, e) {
  if (typeof t == "string") {
    if (!e.nodes[t])
      throw Error(`There is no node type named '${t}'. Maybe you forgot to add the extension?`);
    return e.nodes[t];
  }
  return t;
}
function qe(...t) {
  return t.filter((e) => !!e).reduce((e, n) => {
    const r = { ...e };
    return Object.entries(n).forEach(([o, s]) => {
      if (!r[o]) {
        r[o] = s;
        return;
      }
      if (o === "class") {
        const a = s ? s.split(" ") : [], c = r[o] ? r[o].split(" ") : [], d = a.filter((f) => !c.includes(f));
        r[o] = [...c, ...d].join(" ");
      } else
        o === "style" ? r[o] = [r[o], s].join("; ") : r[o] = s;
    }), r;
  }, {});
}
function Qe(t) {
  return typeof t == "function";
}
function x(t, e = void 0, ...n) {
  return Qe(t) ? e ? t.bind(e)(...n) : t(...n) : t;
}
function Xe(t) {
  return Object.prototype.toString.call(t) === "[object RegExp]";
}
class Ye {
  constructor(e) {
    this.find = e.find, this.handler = e.handler;
  }
}
function Ze(t) {
  return Object.prototype.toString.call(t).slice(8, -1);
}
function H(t) {
  return Ze(t) !== "Object" ? !1 : t.constructor === Object && Object.getPrototypeOf(t) === Object.prototype;
}
function Q(t, e) {
  const n = { ...t };
  return H(t) && H(e) && Object.keys(e).forEach((r) => {
    H(e[r]) ? r in t ? n[r] = Q(t[r], e[r]) : Object.assign(n, { [r]: e[r] }) : Object.assign(n, { [r]: e[r] });
  }), n;
}
class T {
  constructor(e = {}) {
    this.type = "extension", this.name = "extension", this.parent = null, this.child = null, this.config = {
      name: this.name,
      defaultOptions: {}
    }, this.config = {
      ...this.config,
      ...e
    }, this.name = this.config.name, e.defaultOptions && Object.keys(e.defaultOptions).length > 0 && console.warn(`[tiptap warn]: BREAKING CHANGE: "defaultOptions" is deprecated. Please use "addOptions" instead. Found in extension: "${this.name}".`), this.options = this.config.defaultOptions, this.config.addOptions && (this.options = x(w(this, "addOptions", {
      name: this.name
    }))), this.storage = x(w(this, "addStorage", {
      name: this.name,
      options: this.options
    })) || {};
  }
  static create(e = {}) {
    return new T(e);
  }
  configure(e = {}) {
    const n = this.extend();
    return n.options = Q(this.options, e), n.storage = x(w(n, "addStorage", {
      name: n.name,
      options: n.options
    })), n;
  }
  extend(e = {}) {
    const n = new T({ ...this.config, ...e });
    return n.parent = this, this.child = n, n.name = e.name ? e.name : n.parent.name, e.defaultOptions && console.warn(`[tiptap warn]: BREAKING CHANGE: "defaultOptions" is deprecated. Please use "addOptions" instead. Found in extension: "${n.name}".`), n.options = x(w(n, "addOptions", {
      name: n.name
    })), n.storage = x(w(n, "addStorage", {
      name: n.name,
      options: n.options
    })), n;
  }
}
function et(t, e, n) {
  const { from: r, to: o } = e, { blockSeparator: s = `

`, textSerializers: i = {} } = n || {};
  let a = "", c = !0;
  return t.nodesBetween(r, o, (d, f, l, u) => {
    var p;
    const m = i == null ? void 0 : i[d.type.name];
    if (m)
      return d.isBlock && !c && (a += s, c = !0), l && (a += m({
        node: d,
        pos: f,
        parent: l,
        index: u,
        range: e
      })), !1;
    d.isText ? (a += (p = d == null ? void 0 : d.text) === null || p === void 0 ? void 0 : p.slice(Math.max(r, f) - f, o - f), c = !1) : d.isBlock && !c && (a += s, c = !0);
  }), a;
}
function tt(t) {
  return Object.fromEntries(Object.entries(t.nodes).filter(([, e]) => e.spec.toText).map(([e, n]) => [e, n.spec.toText]));
}
T.create({
  name: "clipboardTextSerializer",
  addOptions() {
    return {
      blockSeparator: void 0
    };
  },
  addProseMirrorPlugins() {
    return [
      new B({
        key: new N("clipboardTextSerializer"),
        props: {
          clipboardTextSerializer: () => {
            const { editor: t } = this, { state: e, schema: n } = t, { doc: r, selection: o } = e, { ranges: s } = o, i = Math.min(...s.map((f) => f.$from.pos)), a = Math.max(...s.map((f) => f.$to.pos)), c = tt(n);
            return et(r, { from: i, to: a }, {
              ...this.options.blockSeparator !== void 0 ? { blockSeparator: this.options.blockSeparator } : {},
              textSerializers: c
            });
          }
        }
      })
    ];
  }
});
const nt = () => ({ editor: t, view: e }) => (requestAnimationFrame(() => {
  var n;
  t.isDestroyed || (e.dom.blur(), (n = window == null ? void 0 : window.getSelection()) === null || n === void 0 || n.removeAllRanges());
}), !0), rt = (t = !1) => ({ commands: e }) => e.setContent("", t), ot = () => ({ state: t, tr: e, dispatch: n }) => {
  const { selection: r } = e, { ranges: o } = r;
  return n && o.forEach(({ $from: s, $to: i }) => {
    t.doc.nodesBetween(s.pos, i.pos, (a, c) => {
      if (a.type.isText)
        return;
      const { doc: d, mapping: f } = e, l = d.resolve(f.map(c)), u = d.resolve(f.map(c + a.nodeSize)), p = l.blockRange(u);
      if (!p)
        return;
      const m = xe(p);
      if (a.type.isTextblock) {
        const { defaultType: h } = l.parent.contentMatchAt(l.index());
        e.setNodeMarkup(p.start, h);
      }
      (m || m === 0) && e.lift(p, m);
    });
  }), !0;
}, st = (t) => (e) => t(e), it = () => ({ state: t, dispatch: e }) => Me(t, e), at = (t, e) => ({ editor: n, tr: r }) => {
  const { state: o } = n, s = o.doc.slice(t.from, t.to);
  r.deleteRange(t.from, t.to);
  const i = r.mapping.map(e);
  return r.insert(i, s.content), r.setSelection(new S(r.doc.resolve(i - 1))), !0;
}, ct = () => ({ tr: t, dispatch: e }) => {
  const { selection: n } = t, r = n.$anchor.node();
  if (r.content.size > 0)
    return !1;
  const o = t.selection.$anchor;
  for (let s = o.depth; s > 0; s -= 1)
    if (o.node(s).type === r.type) {
      if (e) {
        const a = o.before(s), c = o.after(s);
        t.delete(a, c).scrollIntoView();
      }
      return !0;
    }
  return !1;
}, lt = (t) => ({ tr: e, state: n, dispatch: r }) => {
  const o = y(t, n.schema), s = e.selection.$anchor;
  for (let i = s.depth; i > 0; i -= 1)
    if (s.node(i).type === o) {
      if (r) {
        const c = s.before(i), d = s.after(i);
        e.delete(c, d).scrollIntoView();
      }
      return !0;
    }
  return !1;
}, dt = (t) => ({ tr: e, dispatch: n }) => {
  const { from: r, to: o } = t;
  return n && e.delete(r, o), !0;
}, ut = () => ({ state: t, dispatch: e }) => Ae(t, e), ft = () => ({ commands: t }) => t.keyboardShortcut("Enter"), pt = () => ({ state: t, dispatch: e }) => Te(t, e);
function z(t, e, n = { strict: !0 }) {
  const r = Object.keys(e);
  return r.length ? r.every((o) => n.strict ? e[o] === t[o] : Xe(e[o]) ? e[o].test(t[o]) : e[o] === t[o]) : !0;
}
function G(t, e, n = {}) {
  return t.find((r) => r.type === e && z(r.attrs, n));
}
function mt(t, e, n = {}) {
  return !!G(t, e, n);
}
function ue(t, e, n = {}) {
  if (!t || !e)
    return;
  let r = t.parent.childAfter(t.parentOffset);
  if (t.parentOffset === r.offset && r.offset !== 0 && (r = t.parent.childBefore(t.parentOffset)), !r.node)
    return;
  const o = G([...r.node.marks], e, n);
  if (!o)
    return;
  let s = r.index, i = t.start() + r.offset, a = s + 1, c = i + r.node.nodeSize;
  for (G([...r.node.marks], e, n); s > 0 && o.isInSet(t.parent.child(s - 1).marks); )
    s -= 1, i -= t.parent.child(s).nodeSize;
  for (; a < t.parent.childCount && mt([...t.parent.child(a).marks], e, n); )
    c += t.parent.child(a).nodeSize, a += 1;
  return {
    from: i,
    to: c
  };
}
function I(t, e) {
  if (typeof t == "string") {
    if (!e.marks[t])
      throw Error(`There is no mark type named '${t}'. Maybe you forgot to add the extension?`);
    return e.marks[t];
  }
  return t;
}
const ht = (t, e = {}) => ({ tr: n, state: r, dispatch: o }) => {
  const s = I(t, r.schema), { doc: i, selection: a } = n, { $from: c, from: d, to: f } = a;
  if (o) {
    const l = ue(c, s, e);
    if (l && l.from <= d && l.to >= f) {
      const u = S.create(i, l.from, l.to);
      n.setSelection(u);
    }
  }
  return !0;
}, gt = (t) => (e) => {
  const n = typeof t == "function" ? t(e) : t;
  for (let r = 0; r < n.length; r += 1)
    if (n[r](e))
      return !0;
  return !1;
};
function fe(t) {
  return t instanceof S;
}
function $(t = 0, e = 0, n = 0) {
  return Math.min(Math.max(t, e), n);
}
function kt(t, e = null) {
  if (!e)
    return null;
  const n = P.atStart(t), r = P.atEnd(t);
  if (e === "start" || e === !0)
    return n;
  if (e === "end")
    return r;
  const o = n.from, s = r.to;
  return e === "all" ? S.create(t, $(0, o, s), $(t.content.size, o, s)) : S.create(t, $(e, o, s), $(e, o, s));
}
function X() {
  return [
    "iPad Simulator",
    "iPhone Simulator",
    "iPod Simulator",
    "iPad",
    "iPhone",
    "iPod"
  ].includes(navigator.platform) || navigator.userAgent.includes("Mac") && "ontouchend" in document;
}
const yt = (t = null, e = {}) => ({ editor: n, view: r, tr: o, dispatch: s }) => {
  e = {
    scrollIntoView: !0,
    ...e
  };
  const i = () => {
    X() && r.dom.focus(), requestAnimationFrame(() => {
      n.isDestroyed || (r.focus(), e != null && e.scrollIntoView && n.commands.scrollIntoView());
    });
  };
  if (r.hasFocus() && t === null || t === !1)
    return !0;
  if (s && t === null && !fe(n.state.selection))
    return i(), !0;
  const a = kt(o.doc, t) || n.state.selection, c = n.state.selection.eq(a);
  return s && (c || o.setSelection(a), c && o.storedMarks && o.setStoredMarks(o.storedMarks), i()), !0;
}, wt = (t, e) => (n) => t.every((r, o) => e(r, { ...n, index: o })), xt = (t, e) => ({ tr: n, commands: r }) => r.insertContentAt({ from: n.selection.from, to: n.selection.to }, t, e), pe = (t) => {
  const e = t.childNodes;
  for (let n = e.length - 1; n >= 0; n -= 1) {
    const r = e[n];
    r.nodeType === 3 && r.nodeValue && /^(\n\s\s|\n)$/.test(r.nodeValue) ? t.removeChild(r) : r.nodeType === 1 && pe(r);
  }
  return t;
};
function te(t) {
  const e = `<body>${t}</body>`, n = new window.DOMParser().parseFromString(e, "text/html").body;
  return pe(n);
}
function D(t, e, n) {
  if (n = {
    slice: !0,
    parseOptions: {},
    ...n
  }, typeof t == "object" && t !== null)
    try {
      return Array.isArray(t) && t.length > 0 ? F.fromArray(t.map((r) => e.nodeFromJSON(r))) : e.nodeFromJSON(t);
    } catch (r) {
      return console.warn("[tiptap warn]: Invalid content.", "Passed value:", t, "Error:", r), D("", e, n);
    }
  if (typeof t == "string") {
    const r = we.fromSchema(e);
    return n.slice ? r.parseSlice(te(t), n.parseOptions).content : r.parse(te(t), n.parseOptions);
  }
  return D("", e, n);
}
function bt(t, e, n) {
  const r = t.steps.length - 1;
  if (r < e)
    return;
  const o = t.steps[r];
  if (!(o instanceof be || o instanceof Se))
    return;
  const s = t.mapping.maps[r];
  let i = 0;
  s.forEach((a, c, d, f) => {
    i === 0 && (i = f);
  }), t.setSelection(P.near(t.doc.resolve(i), n));
}
const St = (t) => t.toString().startsWith("<"), Mt = (t, e, n) => ({ tr: r, dispatch: o, editor: s }) => {
  if (o) {
    n = {
      parseOptions: {},
      updateSelection: !0,
      applyInputRules: !1,
      applyPasteRules: !1,
      ...n
    };
    const i = D(e, s.schema, {
      parseOptions: {
        preserveWhitespace: "full",
        ...n.parseOptions
      }
    });
    if (i.toString() === "<>")
      return !0;
    let { from: a, to: c } = typeof t == "number" ? { from: t, to: t } : { from: t.from, to: t.to }, d = !0, f = !0;
    if ((St(i) ? i : [i]).forEach((p) => {
      p.check(), d = d ? p.isText && p.marks.length === 0 : !1, f = f ? p.isBlock : !1;
    }), a === c && f) {
      const { parent: p } = r.doc.resolve(a);
      p.isTextblock && !p.type.spec.code && !p.childCount && (a -= 1, c += 1);
    }
    let u;
    d ? (Array.isArray(e) ? u = e.map((p) => p.text || "").join("") : typeof e == "object" && e && e.text ? u = e.text : u = e, r.insertText(u, a, c)) : (u = i, r.replaceWith(a, c, u)), n.updateSelection && bt(r, r.steps.length - 1, -1), n.applyInputRules && r.setMeta("applyInputRules", { from: a, text: u }), n.applyPasteRules && r.setMeta("applyPasteRules", { from: a, text: u });
  }
  return !0;
}, At = () => ({ state: t, dispatch: e }) => Ce(t, e), Tt = () => ({ state: t, dispatch: e }) => ve(t, e), Ct = () => ({ state: t, dispatch: e }) => Ee(t, e), vt = () => ({ state: t, dispatch: e }) => Ie(t, e), Et = () => ({ tr: t, state: e, dispatch: n }) => {
  try {
    const r = ce(e.doc, e.selection.$from.pos, -1);
    return r == null ? !1 : (t.join(r, 2), n && n(t), !0);
  } catch {
    return !1;
  }
}, It = () => ({ state: t, dispatch: e, tr: n }) => {
  try {
    const r = ce(t.doc, t.selection.$from.pos, 1);
    return r == null ? !1 : (n.join(r, 2), e && e(n), !0);
  } catch {
    return !1;
  }
}, $t = () => ({ state: t, dispatch: e }) => $e(t, e), Bt = () => ({ state: t, dispatch: e }) => Be(t, e);
function me() {
  return typeof navigator < "u" ? /Mac/.test(navigator.platform) : !1;
}
function Nt(t) {
  const e = t.split(/-(?!$)/);
  let n = e[e.length - 1];
  n === "Space" && (n = " ");
  let r, o, s, i;
  for (let a = 0; a < e.length - 1; a += 1) {
    const c = e[a];
    if (/^(cmd|meta|m)$/i.test(c))
      i = !0;
    else if (/^a(lt)?$/i.test(c))
      r = !0;
    else if (/^(c|ctrl|control)$/i.test(c))
      o = !0;
    else if (/^s(hift)?$/i.test(c))
      s = !0;
    else if (/^mod$/i.test(c))
      X() || me() ? i = !0 : o = !0;
    else
      throw new Error(`Unrecognized modifier name: ${c}`);
  }
  return r && (n = `Alt-${n}`), o && (n = `Ctrl-${n}`), i && (n = `Meta-${n}`), s && (n = `Shift-${n}`), n;
}
const Ot = (t) => ({ editor: e, view: n, tr: r, dispatch: o }) => {
  const s = Nt(t).split(/-(?!$)/), i = s.find((d) => !["Alt", "Ctrl", "Meta", "Shift"].includes(d)), a = new KeyboardEvent("keydown", {
    key: i === "Space" ? " " : i,
    altKey: s.includes("Alt"),
    ctrlKey: s.includes("Ctrl"),
    metaKey: s.includes("Meta"),
    shiftKey: s.includes("Shift"),
    bubbles: !0,
    cancelable: !0
  }), c = e.captureTransaction(() => {
    n.someProp("handleKeyDown", (d) => d(n, a));
  });
  return c == null || c.steps.forEach((d) => {
    const f = d.map(r.mapping);
    f && o && r.maybeStep(f);
  }), !0;
};
function Y(t, e, n = {}) {
  const { from: r, to: o, empty: s } = t.selection, i = e ? y(e, t.schema) : null, a = [];
  t.doc.nodesBetween(r, o, (l, u) => {
    if (l.isText)
      return;
    const p = Math.max(r, u), m = Math.min(o, u + l.nodeSize);
    a.push({
      node: l,
      from: p,
      to: m
    });
  });
  const c = o - r, d = a.filter((l) => i ? i.name === l.node.type.name : !0).filter((l) => z(l.node.attrs, n, { strict: !1 }));
  return s ? !!d.length : d.reduce((l, u) => l + u.to - u.from, 0) >= c;
}
const Pt = (t, e = {}) => ({ state: n, dispatch: r }) => {
  const o = y(t, n.schema);
  return Y(n, o, e) ? Ne(n, r) : !1;
}, jt = () => ({ state: t, dispatch: e }) => Oe(t, e), Ft = (t) => ({ state: e, dispatch: n }) => {
  const r = y(t, e.schema);
  return We(r)(e, n);
}, Lt = () => ({ state: t, dispatch: e }) => Pe(t, e);
function he(t, e) {
  return e.nodes[t] ? "node" : e.marks[t] ? "mark" : null;
}
function ne(t, e) {
  const n = typeof e == "string" ? [e] : e;
  return Object.keys(t).reduce((r, o) => (n.includes(o) || (r[o] = t[o]), r), {});
}
const Rt = (t, e) => ({ tr: n, state: r, dispatch: o }) => {
  let s = null, i = null;
  const a = he(typeof t == "string" ? t : t.name, r.schema);
  return a ? (a === "node" && (s = y(t, r.schema)), a === "mark" && (i = I(t, r.schema)), o && n.selection.ranges.forEach((c) => {
    r.doc.nodesBetween(c.$from.pos, c.$to.pos, (d, f) => {
      s && s === d.type && n.setNodeMarkup(f, void 0, ne(d.attrs, e)), i && d.marks.length && d.marks.forEach((l) => {
        i === l.type && n.addMark(f, f + d.nodeSize, i.create(ne(l.attrs, e)));
      });
    });
  }), !0) : !1;
}, zt = () => ({ tr: t, dispatch: e }) => (e && t.scrollIntoView(), !0), Dt = () => ({ tr: t, commands: e }) => e.setTextSelection({
  from: 0,
  to: t.doc.content.size
}), Wt = () => ({ state: t, dispatch: e }) => je(t, e), Kt = () => ({ state: t, dispatch: e }) => Fe(t, e), Ht = () => ({ state: t, dispatch: e }) => Le(t, e), Vt = () => ({ state: t, dispatch: e }) => Re(t, e), _t = () => ({ state: t, dispatch: e }) => ze(t, e);
function Jt(t, e, n = {}) {
  return D(t, e, { slice: !1, parseOptions: n });
}
const Gt = (t, e = !1, n = {}) => ({ tr: r, editor: o, dispatch: s }) => {
  const { doc: i } = r, a = Jt(t, o.schema, n);
  return s && r.replaceWith(0, i.content.size, a).setMeta("preventUpdate", !e), !0;
};
function Ut(t, e) {
  const n = I(e, t.schema), { from: r, to: o, empty: s } = t.selection, i = [];
  s ? (t.storedMarks && i.push(...t.storedMarks), i.push(...t.selection.$head.marks())) : t.doc.nodesBetween(r, o, (c) => {
    i.push(...c.marks);
  });
  const a = i.find((c) => c.type.name === n.name);
  return a ? { ...a.attrs } : {};
}
function qt(t) {
  for (let e = 0; e < t.edgeCount; e += 1) {
    const { type: n } = t.edge(e);
    if (n.isTextblock && !n.hasRequiredAttrs())
      return n;
  }
  return null;
}
function U(t, e) {
  const n = [];
  return t.descendants((r, o) => {
    e(r) && n.push({
      node: r,
      pos: o
    });
  }), n;
}
function Qt(t, e) {
  for (let n = t.depth; n > 0; n -= 1) {
    const r = t.node(n);
    if (e(r))
      return {
        pos: n > 0 ? t.before(n) : 0,
        start: t.start(n),
        depth: n,
        node: r
      };
  }
}
function Z(t) {
  return (e) => Qt(e.$from, t);
}
function R(t, e, n) {
  return Object.fromEntries(Object.entries(n).filter(([r]) => {
    const o = t.find((s) => s.type === e && s.name === r);
    return o ? o.attribute.keepOnSplit : !1;
  }));
}
function Xt(t, e, n = {}) {
  const { empty: r, ranges: o } = t.selection, s = e ? I(e, t.schema) : null;
  if (r)
    return !!(t.storedMarks || t.selection.$from.marks()).filter((l) => s ? s.name === l.type.name : !0).find((l) => z(l.attrs, n, { strict: !1 }));
  let i = 0;
  const a = [];
  if (o.forEach(({ $from: l, $to: u }) => {
    const p = l.pos, m = u.pos;
    t.doc.nodesBetween(p, m, (h, g) => {
      if (!h.isText && !h.marks.length)
        return;
      const k = Math.max(p, g), C = Math.min(m, g + h.nodeSize), M = C - k;
      i += M, a.push(...h.marks.map((v) => ({
        mark: v,
        from: k,
        to: C
      })));
    });
  }), i === 0)
    return !1;
  const c = a.filter((l) => s ? s.name === l.mark.type.name : !0).filter((l) => z(l.mark.attrs, n, { strict: !1 })).reduce((l, u) => l + u.to - u.from, 0), d = a.filter((l) => s ? l.mark.type !== s && l.mark.type.excludes(s) : !0).reduce((l, u) => l + u.to - u.from, 0);
  return (c > 0 ? c + d : c) >= i;
}
function re(t, e) {
  const { nodeExtensions: n } = Ue(e), r = n.find((i) => i.name === t);
  if (!r)
    return !1;
  const o = {
    name: r.name,
    options: r.options,
    storage: r.storage
  }, s = x(w(r, "group", o));
  return typeof s != "string" ? !1 : s.split(" ").includes("list");
}
function Yt(t, e, n) {
  var r;
  const { selection: o } = e;
  let s = null;
  if (fe(o) && (s = o.$cursor), s) {
    const a = (r = t.storedMarks) !== null && r !== void 0 ? r : s.marks();
    return !!n.isInSet(a) || !a.some((c) => c.type.excludes(n));
  }
  const { ranges: i } = o;
  return i.some(({ $from: a, $to: c }) => {
    let d = a.depth === 0 ? t.doc.inlineContent && t.doc.type.allowsMarkType(n) : !1;
    return t.doc.nodesBetween(a.pos, c.pos, (f, l, u) => {
      if (d)
        return !1;
      if (f.isInline) {
        const p = !u || u.type.allowsMarkType(n), m = !!n.isInSet(f.marks) || !f.marks.some((h) => h.type.excludes(n));
        d = p && m;
      }
      return !d;
    }), d;
  });
}
const Zt = (t, e = {}) => ({ tr: n, state: r, dispatch: o }) => {
  const { selection: s } = n, { empty: i, ranges: a } = s, c = I(t, r.schema);
  if (o)
    if (i) {
      const d = Ut(r, c);
      n.addStoredMark(c.create({
        ...d,
        ...e
      }));
    } else
      a.forEach((d) => {
        const f = d.$from.pos, l = d.$to.pos;
        r.doc.nodesBetween(f, l, (u, p) => {
          const m = Math.max(p, f), h = Math.min(p + u.nodeSize, l);
          u.marks.find((k) => k.type === c) ? u.marks.forEach((k) => {
            c === k.type && n.addMark(m, h, c.create({
              ...k.attrs,
              ...e
            }));
          }) : n.addMark(m, h, c.create(e));
        });
      });
  return Yt(r, n, c);
}, en = (t, e) => ({ tr: n }) => (n.setMeta(t, e), !0), tn = (t, e = {}) => ({ state: n, dispatch: r, chain: o }) => {
  const s = y(t, n.schema);
  return s.isTextblock ? o().command(({ commands: i }) => ee(s, e)(n) ? !0 : i.clearNodes()).command(({ state: i }) => ee(s, e)(i, r)).run() : (console.warn('[tiptap warn]: Currently "setNode()" only supports text block nodes.'), !1);
}, nn = (t) => ({ tr: e, dispatch: n }) => {
  if (n) {
    const { doc: r } = e, o = $(t, 0, r.content.size), s = ae.create(r, o);
    e.setSelection(s);
  }
  return !0;
}, rn = (t) => ({ tr: e, dispatch: n }) => {
  if (n) {
    const { doc: r } = e, { from: o, to: s } = typeof t == "number" ? { from: t, to: t } : t, i = S.atStart(r).from, a = S.atEnd(r).to, c = $(o, i, a), d = $(s, i, a), f = S.create(r, c, d);
    e.setSelection(f);
  }
  return !0;
}, on = (t) => ({ state: e, dispatch: n }) => {
  const r = y(t, e.schema);
  return Ke(r)(e, n);
};
function oe(t, e) {
  const n = t.storedMarks || t.selection.$to.parentOffset && t.selection.$from.marks();
  if (n) {
    const r = n.filter((o) => e == null ? void 0 : e.includes(o.type.name));
    t.tr.ensureMarks(r);
  }
}
const sn = ({ keepMarks: t = !0 } = {}) => ({ tr: e, state: n, dispatch: r, editor: o }) => {
  const { selection: s, doc: i } = e, { $from: a, $to: c } = s, d = o.extensionManager.attributes, f = R(d, a.node().type.name, a.node().attrs);
  if (s instanceof ae && s.node.isBlock)
    return !a.parentOffset || !L(i, a.pos) ? !1 : (r && (t && oe(n, o.extensionManager.splittableMarks), e.split(a.pos).scrollIntoView()), !0);
  if (!a.parent.isBlock)
    return !1;
  if (r) {
    const l = c.parentOffset === c.parent.content.size;
    s instanceof S && e.deleteSelection();
    const u = a.depth === 0 ? void 0 : qt(a.node(-1).contentMatchAt(a.indexAfter(-1)));
    let p = l && u ? [
      {
        type: u,
        attrs: f
      }
    ] : void 0, m = L(e.doc, e.mapping.map(a.pos), 1, p);
    if (!p && !m && L(e.doc, e.mapping.map(a.pos), 1, u ? [{ type: u }] : void 0) && (m = !0, p = u ? [
      {
        type: u,
        attrs: f
      }
    ] : void 0), m && (e.split(e.mapping.map(a.pos), 1, p), u && !l && !a.parentOffset && a.parent.type !== u)) {
      const h = e.mapping.map(a.before()), g = e.doc.resolve(h);
      a.node(-1).canReplaceWith(g.index(), g.index() + 1, u) && e.setNodeMarkup(e.mapping.map(a.before()), u);
    }
    t && oe(n, o.extensionManager.splittableMarks), e.scrollIntoView();
  }
  return !0;
}, an = (t) => ({ tr: e, state: n, dispatch: r, editor: o }) => {
  var s;
  const i = y(t, n.schema), { $from: a, $to: c } = n.selection, d = n.selection.node;
  if (d && d.isBlock || a.depth < 2 || !a.sameParent(c))
    return !1;
  const f = a.node(-1);
  if (f.type !== i)
    return !1;
  const l = o.extensionManager.attributes;
  if (a.parent.content.size === 0 && a.node(-1).childCount === a.indexAfter(-1)) {
    if (a.depth === 2 || a.node(-3).type !== i || a.index(-2) !== a.node(-2).childCount - 1)
      return !1;
    if (r) {
      let g = F.empty;
      const k = a.index(-1) ? 1 : a.index(-2) ? 2 : 3;
      for (let E = a.depth - k; E >= a.depth - 3; E -= 1)
        g = F.from(a.node(E).copy(g));
      const C = a.indexAfter(-1) < a.node(-2).childCount ? 1 : a.indexAfter(-2) < a.node(-3).childCount ? 2 : 3, M = R(l, a.node().type.name, a.node().attrs), v = ((s = i.contentMatch.defaultType) === null || s === void 0 ? void 0 : s.createAndFill(M)) || void 0;
      g = g.append(F.from(i.createAndFill(null, v) || void 0));
      const b = a.before(a.depth - (k - 1));
      e.replace(b, a.after(-C), new ye(g, 4 - k, 0));
      let A = -1;
      e.doc.nodesBetween(b, e.doc.content.size, (E, K) => {
        if (A > -1)
          return !1;
        E.isTextblock && E.content.size === 0 && (A = K + 1);
      }), A > -1 && e.setSelection(S.near(e.doc.resolve(A))), e.scrollIntoView();
    }
    return !0;
  }
  const u = c.pos === a.end() ? f.contentMatchAt(0).defaultType : null, p = R(l, f.type.name, f.attrs), m = R(l, a.node().type.name, a.node().attrs);
  e.delete(a.pos, c.pos);
  const h = u ? [
    { type: i, attrs: p },
    { type: u, attrs: m }
  ] : [{ type: i, attrs: p }];
  if (!L(e.doc, a.pos, 2))
    return !1;
  if (r) {
    const { selection: g, storedMarks: k } = n, { splittableMarks: C } = o.extensionManager, M = k || g.$to.parentOffset && g.$from.marks();
    if (e.split(a.pos, 2, h).scrollIntoView(), !M || !r)
      return !0;
    const v = M.filter((b) => C.includes(b.type.name));
    e.ensureMarks(v);
  }
  return !0;
}, V = (t, e) => {
  const n = Z((i) => i.type === e)(t.selection);
  if (!n)
    return !0;
  const r = t.doc.resolve(Math.max(0, n.pos - 1)).before(n.depth);
  if (r === void 0)
    return !0;
  const o = t.doc.nodeAt(r);
  return n.node.type === (o == null ? void 0 : o.type) && le(t.doc, n.pos) && t.join(n.pos), !0;
}, _ = (t, e) => {
  const n = Z((i) => i.type === e)(t.selection);
  if (!n)
    return !0;
  const r = t.doc.resolve(n.start).after(n.depth);
  if (r === void 0)
    return !0;
  const o = t.doc.nodeAt(r);
  return n.node.type === (o == null ? void 0 : o.type) && le(t.doc, r) && t.join(r), !0;
}, cn = (t, e, n, r = {}) => ({ editor: o, tr: s, state: i, dispatch: a, chain: c, commands: d, can: f }) => {
  const { extensions: l, splittableMarks: u } = o.extensionManager, p = y(t, i.schema), m = y(e, i.schema), { selection: h, storedMarks: g } = i, { $from: k, $to: C } = h, M = k.blockRange(C), v = g || h.$to.parentOffset && h.$from.marks();
  if (!M)
    return !1;
  const b = Z((A) => re(A.type.name, l))(h);
  if (M.depth >= 1 && b && M.depth - b.depth <= 1) {
    if (b.node.type === p)
      return d.liftListItem(m);
    if (re(b.node.type.name, l) && p.validContent(b.node.content) && a)
      return c().command(() => (s.setNodeMarkup(b.pos, p), !0)).command(() => V(s, p)).command(() => _(s, p)).run();
  }
  return !n || !v || !a ? c().command(() => f().wrapInList(p, r) ? !0 : d.clearNodes()).wrapInList(p, r).command(() => V(s, p)).command(() => _(s, p)).run() : c().command(() => {
    const A = f().wrapInList(p, r), E = v.filter((K) => u.includes(K.type.name));
    return s.ensureMarks(E), A ? !0 : d.clearNodes();
  }).wrapInList(p, r).command(() => V(s, p)).command(() => _(s, p)).run();
}, ln = (t, e = {}, n = {}) => ({ state: r, commands: o }) => {
  const { extendEmptyMarkRange: s = !1 } = n, i = I(t, r.schema);
  return Xt(r, i, e) ? o.unsetMark(i, { extendEmptyMarkRange: s }) : o.setMark(i, e);
}, dn = (t, e, n = {}) => ({ state: r, commands: o }) => {
  const s = y(t, r.schema), i = y(e, r.schema);
  return Y(r, s, n) ? o.setNode(i) : o.setNode(s, n);
}, un = (t, e = {}) => ({ state: n, commands: r }) => {
  const o = y(t, n.schema);
  return Y(n, o, e) ? r.lift(o) : r.wrapIn(o, e);
}, fn = () => ({ state: t, dispatch: e }) => {
  const n = t.plugins;
  for (let r = 0; r < n.length; r += 1) {
    const o = n[r];
    let s;
    if (o.spec.isInputRules && (s = o.getState(t))) {
      if (e) {
        const i = t.tr, a = s.transform;
        for (let c = a.steps.length - 1; c >= 0; c -= 1)
          i.step(a.steps[c].invert(a.docs[c]));
        if (s.text) {
          const c = i.doc.resolve(s.from).marks();
          i.replaceWith(s.from, s.to, t.schema.text(s.text, c));
        } else
          i.delete(s.from, s.to);
      }
      return !0;
    }
  }
  return !1;
}, pn = () => ({ tr: t, dispatch: e }) => {
  const { selection: n } = t, { empty: r, ranges: o } = n;
  return r || e && o.forEach((s) => {
    t.removeMark(s.$from.pos, s.$to.pos);
  }), !0;
}, mn = (t, e = {}) => ({ tr: n, state: r, dispatch: o }) => {
  var s;
  const { extendEmptyMarkRange: i = !1 } = e, { selection: a } = n, c = I(t, r.schema), { $from: d, empty: f, ranges: l } = a;
  if (!o)
    return !0;
  if (f && i) {
    let { from: u, to: p } = a;
    const m = (s = d.marks().find((g) => g.type === c)) === null || s === void 0 ? void 0 : s.attrs, h = ue(d, c, m);
    h && (u = h.from, p = h.to), n.removeMark(u, p, c);
  } else
    l.forEach((u) => {
      n.removeMark(u.$from.pos, u.$to.pos, c);
    });
  return n.removeStoredMark(c), !0;
}, hn = (t, e = {}) => ({ tr: n, state: r, dispatch: o }) => {
  let s = null, i = null;
  const a = he(typeof t == "string" ? t : t.name, r.schema);
  return a ? (a === "node" && (s = y(t, r.schema)), a === "mark" && (i = I(t, r.schema)), o && n.selection.ranges.forEach((c) => {
    const d = c.$from.pos, f = c.$to.pos;
    r.doc.nodesBetween(d, f, (l, u) => {
      s && s === l.type && n.setNodeMarkup(u, void 0, {
        ...l.attrs,
        ...e
      }), i && l.marks.length && l.marks.forEach((p) => {
        if (i === p.type) {
          const m = Math.max(u, d), h = Math.min(u + l.nodeSize, f);
          n.addMark(m, h, i.create({
            ...p.attrs,
            ...e
          }));
        }
      });
    });
  }), !0) : !1;
}, gn = (t, e = {}) => ({ state: n, dispatch: r }) => {
  const o = y(t, n.schema);
  return De(o, e)(n, r);
}, kn = (t, e = {}) => ({ state: n, dispatch: r }) => {
  const o = y(t, n.schema);
  return He(o, e)(n, r);
};
var yn = /* @__PURE__ */ Object.freeze({
  __proto__: null,
  blur: nt,
  clearContent: rt,
  clearNodes: ot,
  command: st,
  createParagraphNear: it,
  cut: at,
  deleteCurrentNode: ct,
  deleteNode: lt,
  deleteRange: dt,
  deleteSelection: ut,
  enter: ft,
  exitCode: pt,
  extendMarkRange: ht,
  first: gt,
  focus: yt,
  forEach: wt,
  insertContent: xt,
  insertContentAt: Mt,
  joinUp: At,
  joinDown: Tt,
  joinBackward: Ct,
  joinForward: vt,
  joinItemBackward: Et,
  joinItemForward: It,
  joinTextblockBackward: $t,
  joinTextblockForward: Bt,
  keyboardShortcut: Ot,
  lift: Pt,
  liftEmptyBlock: jt,
  liftListItem: Ft,
  newlineInCode: Lt,
  resetAttributes: Rt,
  scrollIntoView: zt,
  selectAll: Dt,
  selectNodeBackward: Wt,
  selectNodeForward: Kt,
  selectParentNode: Ht,
  selectTextblockEnd: Vt,
  selectTextblockStart: _t,
  setContent: Gt,
  setMark: Zt,
  setMeta: en,
  setNode: tn,
  setNodeSelection: nn,
  setTextSelection: rn,
  sinkListItem: on,
  splitBlock: sn,
  splitListItem: an,
  toggleList: cn,
  toggleMark: ln,
  toggleNode: dn,
  toggleWrap: un,
  undoInputRule: fn,
  unsetAllMarks: pn,
  unsetMark: mn,
  updateAttributes: hn,
  wrapIn: gn,
  wrapInList: kn
});
T.create({
  name: "commands",
  addCommands() {
    return {
      ...yn
    };
  }
});
T.create({
  name: "editable",
  addProseMirrorPlugins() {
    return [
      new B({
        key: new N("editable"),
        props: {
          editable: () => this.editor.options.editable
        }
      })
    ];
  }
});
T.create({
  name: "focusEvents",
  addProseMirrorPlugins() {
    const { editor: t } = this;
    return [
      new B({
        key: new N("focusEvents"),
        props: {
          handleDOMEvents: {
            focus: (e, n) => {
              t.isFocused = !0;
              const r = t.state.tr.setMeta("focus", { event: n }).setMeta("addToHistory", !1);
              return e.dispatch(r), !1;
            },
            blur: (e, n) => {
              t.isFocused = !1;
              const r = t.state.tr.setMeta("blur", { event: n }).setMeta("addToHistory", !1);
              return e.dispatch(r), !1;
            }
          }
        }
      })
    ];
  }
});
T.create({
  name: "keymap",
  addKeyboardShortcuts() {
    const t = () => this.editor.commands.first(({ commands: i }) => [
      () => i.undoInputRule(),
      // maybe convert first text block node to default node
      () => i.command(({ tr: a }) => {
        const { selection: c, doc: d } = a, { empty: f, $anchor: l } = c, { pos: u, parent: p } = l, m = l.parent.isTextblock && u > 0 ? a.doc.resolve(u - 1) : l, h = m.parent.type.spec.isolating, g = l.pos - l.parentOffset, k = h && m.parent.childCount === 1 ? g === l.pos : P.atStart(d).from === u;
        return !f || !k || !p.type.isTextblock || p.textContent.length ? !1 : i.clearNodes();
      }),
      () => i.deleteSelection(),
      () => i.joinBackward(),
      () => i.selectNodeBackward()
    ]), e = () => this.editor.commands.first(({ commands: i }) => [
      () => i.deleteSelection(),
      () => i.deleteCurrentNode(),
      () => i.joinForward(),
      () => i.selectNodeForward()
    ]), r = {
      Enter: () => this.editor.commands.first(({ commands: i }) => [
        () => i.newlineInCode(),
        () => i.createParagraphNear(),
        () => i.liftEmptyBlock(),
        () => i.splitBlock()
      ]),
      "Mod-Enter": () => this.editor.commands.exitCode(),
      Backspace: t,
      "Mod-Backspace": t,
      "Shift-Backspace": t,
      Delete: e,
      "Mod-Delete": e,
      "Mod-a": () => this.editor.commands.selectAll()
    }, o = {
      ...r
    }, s = {
      ...r,
      "Ctrl-h": t,
      "Alt-Backspace": t,
      "Ctrl-d": e,
      "Ctrl-Alt-Backspace": e,
      "Alt-Delete": e,
      "Alt-d": e,
      "Ctrl-a": () => this.editor.commands.selectTextblockStart(),
      "Ctrl-e": () => this.editor.commands.selectTextblockEnd()
    };
    return X() || me() ? s : o;
  },
  addProseMirrorPlugins() {
    return [
      // With this plugin we check if the whole document was selected and deleted.
      // In this case we will additionally call `clearNodes()` to convert e.g. a heading
      // to a paragraph if necessary.
      // This is an alternative to ProseMirror's `AllSelection`, which doesn’t work well
      // with many other commands.
      new B({
        key: new N("clearDocument"),
        appendTransaction: (t, e, n) => {
          if (!(t.some((m) => m.docChanged) && !e.doc.eq(n.doc)))
            return;
          const { empty: o, from: s, to: i } = e.selection, a = P.atStart(e.doc).from, c = P.atEnd(e.doc).to;
          if (o || !(s === a && i === c) || !(n.doc.textBetween(0, n.doc.content.size, " ", " ").length === 0))
            return;
          const l = n.tr, u = de({
            state: n,
            transaction: l
          }), { commands: p } = new Ge({
            editor: this.editor,
            state: u
          });
          if (p.clearNodes(), !!l.steps.length)
            return l;
        }
      })
    ];
  }
});
T.create({
  name: "tabindex",
  addProseMirrorPlugins() {
    return [
      new B({
        key: new N("tabindex"),
        props: {
          attributes: this.editor.isEditable ? { tabindex: "0" } : {}
        }
      })
    ];
  }
});
function se(t) {
  return new Ye({
    find: t.find,
    handler: ({ state: e, range: n, match: r }) => {
      const o = e.doc.resolve(n.from), s = x(t.getAttributes, void 0, r) || {};
      if (!o.node(-1).canReplaceWith(o.index(-1), o.indexAfter(-1), t.type))
        return null;
      e.tr.delete(n.from, n.to).setBlockType(n.from, n.from, t.type, s);
    }
  });
}
class W {
  constructor(e = {}) {
    this.type = "node", this.name = "node", this.parent = null, this.child = null, this.config = {
      name: this.name,
      defaultOptions: {}
    }, this.config = {
      ...this.config,
      ...e
    }, this.name = this.config.name, e.defaultOptions && Object.keys(e.defaultOptions).length > 0 && console.warn(`[tiptap warn]: BREAKING CHANGE: "defaultOptions" is deprecated. Please use "addOptions" instead. Found in extension: "${this.name}".`), this.options = this.config.defaultOptions, this.config.addOptions && (this.options = x(w(this, "addOptions", {
      name: this.name
    }))), this.storage = x(w(this, "addStorage", {
      name: this.name,
      options: this.options
    })) || {};
  }
  static create(e = {}) {
    return new W(e);
  }
  configure(e = {}) {
    const n = this.extend();
    return n.options = Q(this.options, e), n.storage = x(w(n, "addStorage", {
      name: n.name,
      options: n.options
    })), n;
  }
  extend(e = {}) {
    const n = new W({ ...this.config, ...e });
    return n.parent = this, this.child = n, n.name = e.name ? e.name : n.parent.name, e.defaultOptions && console.warn(`[tiptap warn]: BREAKING CHANGE: "defaultOptions" is deprecated. Please use "addOptions" instead. Found in extension: "${n.name}".`), n.options = x(w(n, "addOptions", {
      name: n.name
    })), n.storage = x(w(n, "addStorage", {
      name: n.name,
      options: n.options
    })), n;
  }
}
const wn = /^```([a-z]+)?[\s\n]$/, xn = /^~~~([a-z]+)?[\s\n]$/, bn = W.create({
  name: "codeBlock",
  addOptions() {
    return {
      languageClassPrefix: "language-",
      exitOnTripleEnter: !0,
      exitOnArrowDown: !0,
      HTMLAttributes: {}
    };
  },
  content: "text*",
  marks: "",
  group: "block",
  code: !0,
  defining: !0,
  addAttributes() {
    return {
      language: {
        default: null,
        parseHTML: (t) => {
          var e;
          const { languageClassPrefix: n } = this.options, s = [...((e = t.firstElementChild) === null || e === void 0 ? void 0 : e.classList) || []].filter((i) => i.startsWith(n)).map((i) => i.replace(n, ""))[0];
          return s || null;
        },
        rendered: !1
      }
    };
  },
  parseHTML() {
    return [
      {
        tag: "pre",
        preserveWhitespace: "full"
      }
    ];
  },
  renderHTML({ node: t, HTMLAttributes: e }) {
    return [
      "pre",
      qe(this.options.HTMLAttributes, e),
      [
        "code",
        {
          class: t.attrs.language ? this.options.languageClassPrefix + t.attrs.language : null
        },
        0
      ]
    ];
  },
  addCommands() {
    return {
      setCodeBlock: (t) => ({ commands: e }) => e.setNode(this.name, t),
      toggleCodeBlock: (t) => ({ commands: e }) => e.toggleNode(this.name, "paragraph", t)
    };
  },
  addKeyboardShortcuts() {
    return {
      "Mod-Alt-c": () => this.editor.commands.toggleCodeBlock(),
      // remove code block when at start of document or code block is empty
      Backspace: () => {
        const { empty: t, $anchor: e } = this.editor.state.selection, n = e.pos === 1;
        return !t || e.parent.type.name !== this.name ? !1 : n || !e.parent.textContent.length ? this.editor.commands.clearNodes() : !1;
      },
      // exit node on triple enter
      Enter: ({ editor: t }) => {
        if (!this.options.exitOnTripleEnter)
          return !1;
        const { state: e } = t, { selection: n } = e, { $from: r, empty: o } = n;
        if (!o || r.parent.type !== this.type)
          return !1;
        const s = r.parentOffset === r.parent.nodeSize - 2, i = r.parent.textContent.endsWith(`

`);
        return !s || !i ? !1 : t.chain().command(({ tr: a }) => (a.delete(r.pos - 2, r.pos), !0)).exitCode().run();
      },
      // exit node on arrow down
      ArrowDown: ({ editor: t }) => {
        if (!this.options.exitOnArrowDown)
          return !1;
        const { state: e } = t, { selection: n, doc: r } = e, { $from: o, empty: s } = n;
        if (!s || o.parent.type !== this.type || !(o.parentOffset === o.parent.nodeSize - 2))
          return !1;
        const a = o.after();
        return a === void 0 || r.nodeAt(a) ? !1 : t.commands.exitCode();
      }
    };
  },
  addInputRules() {
    return [
      se({
        find: wn,
        type: this.type,
        getAttributes: (t) => ({
          language: t[1]
        })
      }),
      se({
        find: xn,
        type: this.type,
        getAttributes: (t) => ({
          language: t[1]
        })
      })
    ];
  },
  addProseMirrorPlugins() {
    return [
      // this plugin creates a code block for pasted content from VS Code
      // we can also detect the copied code language
      new B({
        key: new N("codeBlockVSCodeHandler"),
        props: {
          handlePaste: (t, e) => {
            if (!e.clipboardData || this.editor.isActive(this.type.name))
              return !1;
            const n = e.clipboardData.getData("text/plain"), r = e.clipboardData.getData("vscode-editor-data"), o = r ? JSON.parse(r) : void 0, s = o == null ? void 0 : o.mode;
            if (!n || !s)
              return !1;
            const { tr: i } = t.state;
            return i.replaceSelectionWith(this.type.create({ language: s })), i.setSelection(S.near(i.doc.resolve(Math.max(0, i.selection.from - 2)))), i.insertText(n.replace(/\r\n?/g, `
`)), i.setMeta("paste", !0), t.dispatch(i), !0;
          }
        }
      })
    ];
  }
});
let j, O;
const q = /* @__PURE__ */ new Set(), J = /* @__PURE__ */ new Set(), Sn = (t) => {
  if (!j)
    return j = Ve({
      themes: [t.defaultTheme],
      langs: []
    }).then((r) => {
      J.add(t.defaultTheme), O = r;
    }), j;
  if (!O)
    return j;
  const e = t.language;
  if (e && !q.has(e) && e in _e)
    return O.loadLanguage(e).then(() => {
      q.add(e);
    });
  const n = t.theme;
  if (n && !J.has(n) && n in Je)
    return O.loadTheme(n).then(() => {
      J.add(n);
    });
};
function ie({
  doc: t,
  name: e,
  defaultLanguage: n,
  defaultTheme: r
}) {
  const o = [];
  return U(t, (s) => s.type.name === e).forEach((s) => {
    let i = s.pos + 1, a = s.node.attrs.language || n, c = s.node.attrs.theme || r;
    if (Sn({ language: a, theme: c, defaultTheme: r }), q.has(a) || (a = "plaintext"), !O)
      return s.node;
    const d = O.codeToTokensBase(s.node.textContent, {
      lang: a,
      theme: c
    });
    for (const f of d) {
      for (const l of f) {
        const u = i + l.content.length, p = ke.inline(i, u, {
          style: `color: ${l.color}`
        });
        o.push(p), i = u;
      }
      i += 1;
    }
  }), ge.create(t, o);
}
function Mn({
  name: t,
  defaultLanguage: e,
  defaultTheme: n
}) {
  const r = new B({
    key: new N("shiki"),
    state: {
      init: (o, { doc: s }) => ie({
        doc: s,
        name: t,
        defaultLanguage: e,
        defaultTheme: n
      }),
      apply: (o, s, i, a) => {
        const c = i.selection.$head.parent.type.name, d = a.selection.$head.parent.type.name, f = U(
          i.doc,
          (u) => u.type.name === t
        ), l = U(
          a.doc,
          (u) => u.type.name === t
        );
        return o.docChanged && // Apply decorations if:
        // selection includes named node,
        ([c, d].includes(t) || // OR transaction adds/removes named node,
        l.length !== f.length || // OR transaction has changes that completely encapsulte a node
        // (for example, a transaction that affects the entire document).
        // Such transactions can happen during collab syncing via y-prosemirror, for example.
        o.steps.some((u) => (
          // @ts-ignore
          u.from !== void 0 && // @ts-ignore
          u.to !== void 0 && f.some((p) => (
            // @ts-ignore
            p.pos >= u.from && // @ts-ignore
            p.pos + p.node.nodeSize <= u.to
          ))
        ))) ? ie({
          doc: o.doc,
          name: t,
          defaultLanguage: e,
          defaultTheme: n
        }) : s.map(o.mapping, o.doc);
      }
    },
    props: {
      decorations(o) {
        return r.getState(o);
      }
    }
  });
  return r;
}
const Nn = bn.extend({
  addOptions() {
    var t;
    return {
      ...(t = this.parent) == null ? void 0 : t.call(this),
      defaultLanguage: null,
      defaultTheme: "github-dark"
    };
  },
  addProseMirrorPlugins() {
    var t;
    return [
      ...((t = this.parent) == null ? void 0 : t.call(this)) || [],
      Mn({
        name: this.name,
        defaultLanguage: this.options.defaultLanguage,
        defaultTheme: this.options.defaultTheme
      })
    ];
  }
});
export {
  Nn as CodeBlockShiki,
  Nn as default
};
